# -*- coding: utf-8 -*-
##############################################
#
# ChriCar Beteiligungs- und Beratungs- GmbH
# Copyright (C) ChriCar Beteiligungs- und Beratungs- GmbH
# all rights reserved
# created 2008-11-08 14:10:01+01
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs.
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company.
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/> or
# write to the Free Software Foundation, Inc., 
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
###############################################
from osv import fields,osv
from tools.sql import drop_view_if_exists

class dimu_partner_category_country(osv.osv):
    _name = "dimu.partner_category_country"
    _auto = False
    _columns = \
        { 'category_id'        : fields.many2one('res.partner.category','Category', readonly=True)
        , 'partner_id'         : fields.many2one('res.partner', 'Partner', readonly=True)
        , 'partner_address_id' : fields.many2one('res.partner.address', 'Kontakt', readonly=True)
        , 'email'              : fields.char    ('EMail', size=64, readonly=True)
        , 'website'            : fields.char    ('Web', size=64, readonly=True)
        , 'phone'              : fields.char    ('Phone', size=64, readonly=True)
        , 'mobile'             : fields.char    ('Mobile', size=64, readonly=True)
        , 'country_id'         : fields.many2one('res.country','Country', readonly=True)
        , 'zip'                : fields.char    ('Zip', size=64, readonly=True)
        , 'city'               : fields.char    ('City', size=64, readonly=True)
        , 'street'             : fields.char    ('Street', size=64, readonly=True)
        }

    def init(self, cr):
        drop_view_if_exists(cr, 'dimu_partner_category_country')
# get_id('dimu_partner_category_country',r.category_id,p.id,a.id,0 ) as id,
# nextval('dimu_partner_category_country_id_seq'::regclass) as id,
#        cr.execute("""drop sequence dimu_partner_category_country_id_seq""")
#        cr.execute("""create sequence dimu_partner_category_country_id_seq""")
#        cr.commit()
# 
#create sequence dimu_partner_category_country_id_seq cache 2000 CYCLE maxvalue 1000000;
#create or replace rule dimu_partner_category_country_rule as on update  to dimu_partner_category_country do instead nothing;
        cr.execute("""
create view dimu_partner_category_country
        as (
        select 
        nextval('dimu_partner_category_country_id_seq'::regclass)::int as id,
        r.category_id ,
        p.id as partner_id,
        a.id as partner_address_id,
        a.email,
        p.website,
        a.phone,
        a.mobile,
        a.country_id,
        a.zip,
        a.city,
        a.street
        from res_partner p,
             res_partner_address a,
             res_partner_category_rel r
        where a.partner_id = p.id
          and r.partner_id = p.id
           );""")

dimu_partner_category_country()


#class res_country(osv.osv):
#    _inherit = "res.country"
#    _columns = \
#        {'partner_category_country_ids' : fields.one2many
#            ('dimu.partner_category_country','country_id','Country')
#        }

#    def unlink(self, cr, uid, ids, context={}):
#        for obj in self.browse(cr, uid, ids, context) :
#            if obj.partner_category_country_ids :
#                raise osv.except_osv \
#                    ( _('Data model error !')
#                    , _('This country cannot be deleted. Data depend on it')
#                    )
#        return super(res_country, self).unlink(cr, uid, ids, context)
    # end def unlink
#res_country()
